
;  GNU C 2.7.2 [AL 1.1, MM 40] RISC NEWS-OS compiled by CC

;  Cc1 defaults:
;  -mmemcpy

;  Cc1 arguments (-G value = 0, Cpu = 3000, ISA = 1):
;  -quiet -dumpbase -O2 -Wall -o

gcc2_compiled.:
__gnu_compiled_c:
; APP
	
		.code
		.align		1
		.global		vecf_conv
		.global		matf_conv
vecf_conv:	;---------------------------------------;
		jp.d		vecf_matf_conv
		ld.w		%r4, 3			; %r4  := cnt = 3					*delay*
matf_conv:	;---------------------------------------;
		ld.w		%r4, 12			; %r4  := cnt = 12
vecf_matf_conv:	;---------------------------------------;
		ld.w		%r5, %r12		; %r5  := (float*)dst
		ld.w		%r6, %r13		; %r6  := (fixed*)src
	ext	0x750		; 		xld.w		%r7, 0x3a800000		; %r7  := (1.0f / 1024.0f)
	ext	0x0
	ld.w	%r7,0x0
vecf_matf_conv_loop:
		ld.w		%r12, [%r6]+		; %r12 := x = (fixed)*src++
	ext	__floatsisf@rm	; 		xcall		__floatsisf		; %r10 := f = (float)x
	call	__floatsisf@rl
		;//
		ld.w		%r12, %r10		; %r12 := f
	ext	__mulsf3@rm	; 		xcall.d		__mulsf3		; %r10 := f *= (1.0f / 1024.0f)
	call.d	__mulsf3@rl
		ld.w		%r13, %r7		; %r13 :=      (1.0f / 1024.0f)				*delay*
		;//
		ld.w		[%r5]+, %r10		; *dst++ = f
		sub		%r4, 1			; %r4  := cnt--
		jrne		vecf_matf_conv_loop
		ret

	
		.code
		.align		1
		.global		vecx_conv
		.global		matx_conv
vecx_conv:	;---------------------------------------;
		jp.d		vecx_matx_conv
		ld.w		%r4, 3			; %r4  := cnt = 3					*delay*
matx_conv:	;---------------------------------------;
		ld.w		%r4, 12			; %r4  := cnt = 12
vecx_matx_conv:	;---------------------------------------;
		ld.w		%r5, %r12		; %r5  := (fixed*)dst
		ld.w		%r6, %r13		; %r6  := (float*)src
	ext	0x890		; 		xld.w		%r7, 0x44800000		; %r7  := 1024.0f
	ext	0x0
	ld.w	%r7,0x0
vecx_matx_conv_loop:
		ld.w		%r12, [%r6]+		; %r12 := f = (float)*src++
	ext	__mulsf3@rm	; 		xcall.d		__mulsf3		; %r10 := f *= 1024.0f
	call.d	__mulsf3@rl
		ld.w		%r13, %r7		; %r13 :=      1024.0f					*delay*
		;//
	ext	__fixsfsi@rm	; 		xcall.d		__fixsfsi		; %r10 := x = (fixed)f
	call.d	__fixsfsi@rl
		ld.w		%r12, %r10		; %r12 := x						*delay*
		;//
		ld.w		[%r5]+, %r10		; *dst++ = f
		sub		%r4, 1			; %r4  := cnt--
		jrne		vecx_matx_conv_loop
		ret

; NO_APP
	.global	vecf_0
	.code
	.align	2
vecf_0:
	.word	0x00000000		; 0 (float)
	.word	0x00000000		; 0 (float)
	.word	0x00000000		; 0 (float)
	.global	vecf_1
	.align	2
vecf_1:
	.word	0x3f800000		; 1 (float)
	.word	0x3f800000		; 1 (float)
	.word	0x3f800000		; 1 (float)
	.global	vecf_x
	.align	2
vecf_x:
	.word	0x3f800000		; 1 (float)
	.word	0x00000000		; 0 (float)
	.word	0x00000000		; 0 (float)
	.global	vecf_y
	.align	2
vecf_y:
	.word	0x00000000		; 0 (float)
	.word	0x3f800000		; 1 (float)
	.word	0x00000000		; 0 (float)
	.global	vecf_z
	.align	2
vecf_z:
	.word	0x00000000		; 0 (float)
	.word	0x00000000		; 0 (float)
	.word	0x3f800000		; 1 (float)
; APP
	
		.code
		.align		1
		.global		vecf_add
		.global		vecf_sub
		.global		vecf_mul
		.global		vecf_div
		.global		vecf_neg
vecf_neg:
	ext	__negsf2+0x0@h	; 		xld.w		%r4, __negsf2
	ext	__negsf2+0x0@m
	ld.w	%r4,__negsf2+0x0@l
		jp.d		vecf_op
		ld.w		%r13, %r12		; vec2̓_~[̓ǂݍ݂ɂȂ܂B			*delay*
		;---------------------------------------;
vecf_div:
	ext	__divsf3+0x0@h	; 		xld.w		%r4, __divsf3
	ext	__divsf3+0x0@m
	ld.w	%r4,__divsf3+0x0@l
		jp		vecf_op
		;---------------------------------------;
vecf_mul:
	ext	__mulsf3+0x0@h	; 		xld.w		%r4, __mulsf3
	ext	__mulsf3+0x0@m
	ld.w	%r4,__mulsf3+0x0@l
		jp		vecf_op
		;---------------------------------------;
vecf_sub:
	ext	__subsf3+0x0@h	; 		xld.w		%r4, __subsf3
	ext	__subsf3+0x0@m
	ld.w	%r4,__subsf3+0x0@l
		jp		vecf_op
		;---------------------------------------;
vecf_add:
	ext	__addsf3+0x0@h	; 		xld.w		%r4, __addsf3
	ext	__addsf3+0x0@m
	ld.w	%r4,__addsf3+0x0@l
		;---------------------------------------;
vecf_op:
		ld.w		%r5, %r12		; %r5  := vec1
		ld.w		%r6, %r13		; %r6  := vec2
		ld.w		%r7, 3			; %r7  := cnt
vecf_op_loop:
		ld.w		%r12, [%r5]		; %r12 := vec1->x
		ld.w		%r13, [%r6]+		; %r13 :=           vec2->x
		call		%r4			; %r10 := vec1->x + vec2->x
		ld.w		[%r5]+, %r10
		sub		%r7, 1			; %r7  := cnt--
		jrne		vecf_op_loop
		ret

	
		.code
		.align		1
		.global		vecf_normal
vecf_normal:
	sub	%sp,0x3		; 		xsub		%sp, %sp, 12
	ld.w	[%sp+0x0],%r12	; 		xld.w		[%sp+0], %r12		; [%sp+0] := vec
	call	vecf_mag	; 		xcall		vecf_mag		; %r10    := mag
	ld.w	%r12,[%sp+0x0]	; 		xld.w		%r12, [%sp+0]		; %r12    := vec
	ld.w	[%sp+0x0],%r10	; 		xld.w		[%sp+0], %r10
	ld.w	[%sp+0x1],%r10	; 		xld.w		[%sp+4], %r10
	ld.w	[%sp+0x2],%r10	; 		xld.w		[%sp+8], %r10
		ld.w		%r13, %sp		; %r13    :=       [mag,mag,mag]
	call	vecf_div	; 		xcall		vecf_div		; %r10    := vec / [mag,mag,mag]
	add	%sp,0x3		; 		xadd		%sp, %sp, 12
		ret

	
		.code
		.align		1
		.global		vecf_mag
		.global		vecf_mag2
		.global		vecf_dot
vecf_mag:
		call		vecf_mag2
	ext	sqrtf@rm	; 		xjp.d		sqrtf
	jp.d	sqrtf@rl
		ld.w		%r12, %r10		;							*delay*
		;---------------------------------------;
vecf_mag2:
		ld.w		%r13, %r12
		;---------------------------------------;
vecf_dot:
		ld.w		%r4, %r12		; %r4  := vec1
		ld.w		%r5, %r13		; %r5  := vec2
		ld.w		%r6, 3			; %r6  := cnt
		ld.w		%r7, 0			; %r7  := sum
vecf_dot_loop:
		ld.w		%r12, [%r4]+		; %r12 := vec1->x
		ld.w		%r13, [%r5]+		; %r13 :=           vec2->x
	ext	__mulsf3@rm	; 		xcall		__mulsf3		; %r10 := vec1->x * vec2->x
	call	__mulsf3@rl
		ld.w		%r12, %r10		; %r13 := vec1->x * vec2->x
	ext	__addsf3@rm	; 		xcall.d		__addsf3		; %r10 := vec1->x * vec2->x + sum
	call.d	__addsf3@rl
		ld.w		%r13, %r7		; %r12 :=                     sum			*delay*
		sub		%r6, 1			; %r6  := cnt--
		jrne.d		vecf_dot_loop
		ld.w		%r7, %r10		; %r7  := sum						*delay*
		ret.d
		ld.w		%r10, %r7		; %r10 := sum						*delay*

	
		.code
		.align		1
		.global		vecf_cross
vecf_cross:
		pushn		%r3
		ld.w		%r0, %r12		; %r0  := ʂi[\̂̃AhX
		ld.w		%r1, [%r13]+		; %r1  := vec1->x
		ld.w		%r2, [%r13]+		; %r2  := vec1->y
		ld.w		%r3, [%r13]		; %r3  := vec1->z
		ld.w		%r4, [%r14]+		; %r4  := vec2->x
		ld.w		%r5, [%r14]+		; %r5  := vec2->y
		ld.w		%r6, [%r14]		; %r6  := vec2->z
		;//
		ld.w		%r12, %r2		; %r12 := vec1->y
	ext	__mulsf3@rm	; 		xcall.d		__mulsf3		; %r10 := vec1->y * vec2->z
	call.d	__mulsf3@rl
		ld.w		%r13, %r6		; %r13 :=           vec2->z				*delay*
		ld.w		%r7, %r10		; %r7  := vec1->y * vec2->z
		ld.w		%r12, %r3		; %r12 :=                     vec1->z
	ext	__mulsf3@rm	; 		xcall.d		__mulsf3		; %r10 :=                     vec1->z * vec2->y
	call.d	__mulsf3@rl
		ld.w		%r13, %r5		; %r13 :=                               vec2->y		*delay*
		ld.w		%r12, %r7		; %r12 := vec1->y * vec2->z
	ext	__subsf3@rm	; 		xcall.d		__subsf3		; %r10 := vec1->y * vec2->z - vec1->z * vec2->y
	call.d	__subsf3@rl
		ld.w		%r13, %r10		; %r13 :=                     vec1->z * vec2->y		*delay*
		ld.w		[%r0]+, %r10
		;//
		ld.w		%r12, %r3		; %r12 := vec1->z
	ext	__mulsf3@rm	; 		xcall.d		__mulsf3		; %r10 := vec1->z * vec2->x
	call.d	__mulsf3@rl
		ld.w		%r13, %r4		; %r13 :=           vec2->x				*delay*
		ld.w		%r7, %r10		; %r7  := vec1->z * vec2->x
		ld.w		%r12, %r1		; %r12 :=                     vec1->x
	ext	__mulsf3@rm	; 		xcall.d		__mulsf3		; %r10 :=                     vec1->x * vec2->z
	call.d	__mulsf3@rl
		ld.w		%r13, %r6		; %r13 :=                               vec2->z		*delay*
		ld.w		%r12, %r7		; %r12 := vec1->z * vec2->x
	ext	__subsf3@rm	; 		xcall.d		__subsf3		; %r10 := vec1->z * vec2->x - vec1->x * vec2->z
	call.d	__subsf3@rl
		ld.w		%r13, %r10		; %r13 :=                     vec1->x * vec2->z		*delay*
		ld.w		[%r0]+, %r10
		;//
		ld.w		%r12, %r1		; %r12 := vec1->x
	ext	__mulsf3@rm	; 		xcall.d		__mulsf3		; %r10 := vec1->x * vec2->y
	call.d	__mulsf3@rl
		ld.w		%r13, %r5		; %r13 :=           vec2->y				*delay*
		ld.w		%r7, %r10		; %r7  := vec1->x * vec2->y
		ld.w		%r12, %r2		; %r12 :=                     vec1->y
	ext	__mulsf3@rm	; 		xcall.d		__mulsf3		; %r10 :=                     vec1->y * vec2->x
	call.d	__mulsf3@rl
		ld.w		%r13, %r4		; %r13 :=                               vec2->x		*delay*
		ld.w		%r12, %r7		; %r12 := vec1->x * vec2->y
	ext	__subsf3@rm	; 		xcall.d		__subsf3		; %r10 := vec1->x * vec2->y - vec1->y * vec2->x
	call.d	__subsf3@rl
		ld.w		%r13, %r10		; %r13 :=                     vec1->y * vec2->x		*delay*
		ld.w		[%r0]+, %r10
		;//
		ld.w		%r10, %r0		; %r10 := ʂi[\̂̃AhX + 12
		popn		%r3
		ret.d
		sub		%r10, 12		; %r10 := ʂi[\̂̃AhX		*delay*

; NO_APP
	.global	matf_0
	.align	2
matf_0:
	.word	0x00000000		; 0 (float)
	.word	0x00000000		; 0 (float)
	.word	0x00000000		; 0 (float)
	.word	0x00000000		; 0 (float)
	.word	0x00000000		; 0 (float)
	.word	0x00000000		; 0 (float)
	.word	0x00000000		; 0 (float)
	.word	0x00000000		; 0 (float)
	.word	0x00000000		; 0 (float)
	.word	0x00000000		; 0 (float)
	.word	0x00000000		; 0 (float)
	.word	0x00000000		; 0 (float)
	.global	matf_1
	.align	2
matf_1:
	.word	0x3f800000		; 1 (float)
	.word	0x00000000		; 0 (float)
	.word	0x00000000		; 0 (float)
	.word	0x00000000		; 0 (float)
	.word	0x00000000		; 0 (float)
	.word	0x3f800000		; 1 (float)
	.word	0x00000000		; 0 (float)
	.word	0x00000000		; 0 (float)
	.word	0x00000000		; 0 (float)
	.word	0x00000000		; 0 (float)
	.word	0x3f800000		; 1 (float)
	.word	0x00000000		; 0 (float)
	.code
	.align	1
	.global	matf_xlate
matf_xlate:
;	.frame	%sp,52,$31		# vars= 48, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	sub	%sp,0xc		; 	xsub	%sp,%sp,48
	ext	0x7f0		; 	xld.w	%r10,0x3f800000		; 1.00000000000000000000e0
	ext	0x0
	ld.w	%r10,0x0
	ld.w	[%sp+0x0],%r10	; 	xld.w	[%sp],%r10
	ld.w	%r11,0x0	; 	xld.w	%r11,0x00000000		; 0.00000000000000000000e0
	ld.w	[%sp+0x1],%r11	; 	xld.w	[%sp+4],%r11
	ld.w	[%sp+0x2],%r11	; 	xld.w	[%sp+8],%r11
	ld.w	[%sp+0x3],%r13	; 	xld.w	[%sp+12],%r13
	ld.w	[%sp+0x4],%r11	; 	xld.w	[%sp+16],%r11
	ld.w	[%sp+0x5],%r10	; 	xld.w	[%sp+20],%r10
	ld.w	[%sp+0x6],%r11	; 	xld.w	[%sp+24],%r11
	ld.w	[%sp+0x7],%r14	; 	xld.w	[%sp+28],%r14
	ld.w	[%sp+0x8],%r11	; 	xld.w	[%sp+32],%r11
	ld.w	[%sp+0x9],%r11	; 	xld.w	[%sp+36],%r11
	ld.w	[%sp+0xa],%r10	; 	xld.w	[%sp+40],%r10
	ld.w	[%sp+0xb],%r15	; 	xld.w	[%sp+44],%r15
	ld.w	%r13,%sp
	ext	matf_xform@rm	; 	xcall	matf_xform
	call	matf_xform@rl
	add	%sp,0xc		; 	xadd	%sp,%sp,48
	ret
	.align	1
	.global	matf_scale
matf_scale:
;	.frame	%sp,52,$31		# vars= 48, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	sub	%sp,0xc		; 	xsub	%sp,%sp,48
	ld.w	[%sp+0x0],%r13	; 	xld.w	[%sp],%r13
	ld.w	%r10,0x0	; 	xld.w	%r10,0x00000000		; 0.00000000000000000000e0
	ld.w	[%sp+0x1],%r10	; 	xld.w	[%sp+4],%r10
	ld.w	[%sp+0x2],%r10	; 	xld.w	[%sp+8],%r10
	ld.w	[%sp+0x3],%r10	; 	xld.w	[%sp+12],%r10
	ld.w	[%sp+0x4],%r10	; 	xld.w	[%sp+16],%r10
	ld.w	[%sp+0x5],%r14	; 	xld.w	[%sp+20],%r14
	ld.w	[%sp+0x6],%r10	; 	xld.w	[%sp+24],%r10
	ld.w	[%sp+0x7],%r10	; 	xld.w	[%sp+28],%r10
	ld.w	[%sp+0x8],%r10	; 	xld.w	[%sp+32],%r10
	ld.w	[%sp+0x9],%r10	; 	xld.w	[%sp+36],%r10
	ld.w	[%sp+0xa],%r15	; 	xld.w	[%sp+40],%r15
	ld.w	[%sp+0xb],%r10	; 	xld.w	[%sp+44],%r10
	ld.w	%r13,%sp
	ext	matf_xform@rm	; 	xcall	matf_xform
	call	matf_xform@rl
	add	%sp,0xc		; 	xadd	%sp,%sp,48
	ret
	.align	1
	.global	matf_rot
matf_rot:
;	.frame	%sp,148,$31		# vars= 128, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	sub	%sp,0x20	; 	xsub	%sp,%sp,128
	ld.w	[%sp+0x1b],%r12	; 	xld.w	[%sp+108],%r12
	ld.w	%r1,%r13
	ld.w	%r0,%r14
	ld.w	%r12,%r0
	ext	sinf@rm		; 	xcall	sinf
	call	sinf@rl
	ld.w	[%sp+0x1c],%r10	; 	xld.w	[%sp+112],%r10
	ld.w	%r12,%r0
	ext	cosf@rm		; 	xcall	cosf
	call	cosf@rl
	ld.w	[%sp+0x1d],%r10	; 	xld.w	[%sp+116],%r10
	ext	0x7f0		; 	xld.w	%r12,0x3f800000		; 1.00000000000000000000e0
	ext	0x0
	ld.w	%r12,0x0
	ld.w	%r13,[%sp+0x1d]	; 	xld.w	%r13,[%sp+116]
	ext	__subsf3@rm	; 	xcall	__subsf3
	call	__subsf3@rl
	ld.w	%r3,%r10
	ld.w	%r12,%sp
	ld.w	%r13,%r1
	ld.w	%r14,0xc	; 	xld.w	%r14,0x0000000c		; 12
	ext	memcpy@rm	; 	xcall	memcpy
	call	memcpy@rl
	ld.w	%r12,%sp
	ext	vecf_normal@rm	; 	xcall	vecf_normal
	call	vecf_normal@rl
	ld.w	%r12,[%sp+0x0]	; 	xld.w	%r12,[%sp]
	ld.w	%r13,[%sp+0x0]	; 	xld.w	%r13,[%sp]
	ext	__mulsf3@rm	; 	xcall	__mulsf3
	call	__mulsf3@rl
	ld.w	%r12,%r10
	ld.w	%r13,%r3
	ext	__mulsf3@rm	; 	xcall	__mulsf3
	call	__mulsf3@rl
	ld.w	%r12,%r10
	ld.w	%r13,[%sp+0x1d]	; 	xld.w	%r13,[%sp+116]
	ext	__addsf3@rm	; 	xcall	__addsf3
	call	__addsf3@rl
	ld.w	[%sp+0xf],%r10	; 	xld.w	[%sp+60],%r10
	ld.w	%r0,[%sp+0x1]	; 	xld.w	%r0,[%sp+4]
	ld.w	%r12,[%sp+0x0]	; 	xld.w	%r12,[%sp]
	ld.w	%r13,%r0
	ext	__mulsf3@rm	; 	xcall	__mulsf3
	call	__mulsf3@rl
	ld.w	%r12,%r10
	ld.w	%r13,%r3
	ext	__mulsf3@rm	; 	xcall	__mulsf3
	call	__mulsf3@rl
	ld.w	%r2,%r10
	ld.w	%r12,[%sp+0x2]	; 	xld.w	%r12,[%sp+8]
	ld.w	%r13,[%sp+0x1c]	; 	xld.w	%r13,[%sp+112]
	ext	__mulsf3@rm	; 	xcall	__mulsf3
	call	__mulsf3@rl
	ld.w	%r1,%r10
	ld.w	%r12,%r2
	ld.w	%r13,%r1
	ext	__subsf3@rm	; 	xcall	__subsf3
	call	__subsf3@rl
	ld.w	[%sp+0x10],%r10	; 	xld.w	[%sp+64],%r10
	ld.w	%r12,[%sp+0x0]	; 	xld.w	%r12,[%sp]
	ld.w	%r13,[%sp+0x2]	; 	xld.w	%r13,[%sp+8]
	ext	__mulsf3@rm	; 	xcall	__mulsf3
	call	__mulsf3@rl
	ld.w	%r12,%r10
	ld.w	%r13,%r3
	ext	__mulsf3@rm	; 	xcall	__mulsf3
	call	__mulsf3@rl
	ld.w	[%sp+0x1e],%r10	; 	xld.w	[%sp+120],%r10
	ld.w	%r12,%r0
	ld.w	%r13,[%sp+0x1c]	; 	xld.w	%r13,[%sp+112]
	ext	__mulsf3@rm	; 	xcall	__mulsf3
	call	__mulsf3@rl
	ld.w	[%sp+0x1f],%r10	; 	xld.w	[%sp+124],%r10
	ld.w	%r12,[%sp+0x1e]	; 	xld.w	%r12,[%sp+120]
	ld.w	%r13,[%sp+0x1f]	; 	xld.w	%r13,[%sp+124]
	ext	__addsf3@rm	; 	xcall	__addsf3
	call	__addsf3@rl
	ld.w	[%sp+0x11],%r10	; 	xld.w	[%sp+68],%r10
	ld.w	%r11,0x0	; 	xld.w	%r11,0x00000000		; 0.00000000000000000000e0
	ld.w	[%sp+0x12],%r11	; 	xld.w	[%sp+72],%r11
	ld.w	%r12,%r2
	ld.w	%r13,%r1
	ext	__addsf3@rm	; 	xcall	__addsf3
	call	__addsf3@rl
	ld.w	[%sp+0x13],%r10	; 	xld.w	[%sp+76],%r10
	ld.w	%r12,%r0
	ld.w	%r13,%r0
	ext	__mulsf3@rm	; 	xcall	__mulsf3
	call	__mulsf3@rl
	ld.w	%r12,%r10
	ld.w	%r13,%r3
	ext	__mulsf3@rm	; 	xcall	__mulsf3
	call	__mulsf3@rl
	ld.w	%r12,%r10
	ld.w	%r13,[%sp+0x1d]	; 	xld.w	%r13,[%sp+116]
	ext	__addsf3@rm	; 	xcall	__addsf3
	call	__addsf3@rl
	ld.w	[%sp+0x14],%r10	; 	xld.w	[%sp+80],%r10
	ld.w	%r12,%r0
	ld.w	%r13,[%sp+0x2]	; 	xld.w	%r13,[%sp+8]
	ext	__mulsf3@rm	; 	xcall	__mulsf3
	call	__mulsf3@rl
	ld.w	%r12,%r10
	ld.w	%r13,%r3
	ext	__mulsf3@rm	; 	xcall	__mulsf3
	call	__mulsf3@rl
	ld.w	%r1,%r10
	ld.w	%r12,[%sp+0x0]	; 	xld.w	%r12,[%sp]
	ld.w	%r13,[%sp+0x1c]	; 	xld.w	%r13,[%sp+112]
	ext	__mulsf3@rm	; 	xcall	__mulsf3
	call	__mulsf3@rl
	ld.w	%r0,%r10
	ld.w	%r12,%r1
	ld.w	%r13,%r0
	ext	__subsf3@rm	; 	xcall	__subsf3
	call	__subsf3@rl
	ld.w	[%sp+0x15],%r10	; 	xld.w	[%sp+84],%r10
	ld.w	%r11,0x0	; 	xld.w	%r11,0x00000000		; 0.00000000000000000000e0
	ld.w	[%sp+0x16],%r11	; 	xld.w	[%sp+88],%r11
	ld.w	%r12,[%sp+0x1e]	; 	xld.w	%r12,[%sp+120]
	ld.w	%r13,[%sp+0x1f]	; 	xld.w	%r13,[%sp+124]
	ext	__subsf3@rm	; 	xcall	__subsf3
	call	__subsf3@rl
	ld.w	[%sp+0x17],%r10	; 	xld.w	[%sp+92],%r10
	ld.w	%r12,%r1
	ld.w	%r13,%r0
	ext	__addsf3@rm	; 	xcall	__addsf3
	call	__addsf3@rl
	ld.w	[%sp+0x18],%r10	; 	xld.w	[%sp+96],%r10
	ld.w	%r12,[%sp+0x2]	; 	xld.w	%r12,[%sp+8]
	ld.w	%r13,%r12
	ext	__mulsf3@rm	; 	xcall	__mulsf3
	call	__mulsf3@rl
	ld.w	%r12,%r10
	ld.w	%r13,%r3
	ext	__mulsf3@rm	; 	xcall	__mulsf3
	call	__mulsf3@rl
	ld.w	%r12,%r10
	ld.w	%r13,[%sp+0x1d]	; 	xld.w	%r13,[%sp+116]
	ext	__addsf3@rm	; 	xcall	__addsf3
	call	__addsf3@rl
	ld.w	[%sp+0x19],%r10	; 	xld.w	[%sp+100],%r10
	ld.w	%r11,0x0	; 	xld.w	%r11,0x00000000		; 0.00000000000000000000e0
	ld.w	[%sp+0x1a],%r11	; 	xld.w	[%sp+104],%r11
	ld.w	%r0,%sp		; 	xadd	%r0,%sp,12
	add	%r0,0xc
	ld.w	%r12,%r0
	ld.w	%r13,%sp	; 	xadd	%r13,%sp,60
	add	%r13,0x3c
	ext	0x0		; 	xld.w	%r14,0x00000030		; 48
	ld.w	%r14,0x30
	ext	memcpy@rm	; 	xcall	memcpy
	call	memcpy@rl
	ld.w	%r12,[%sp+0x1b]	; 	xld.w	%r12,[%sp+108]
	ld.w	%r13,%r0
	ext	matf_xform@rm	; 	xcall	matf_xform
	call	matf_xform@rl
	add	%sp,0x20	; 	xadd	%sp,%sp,128
	popn	%r3
	ret
	.align	1
	.global	matf_rotx
matf_rotx:
;	.frame	%sp,64,$31		# vars= 48, regs= 4/0, args= 0, extra= 0
;	.mask	0x80070000,-4
;	.fmask	0x00000000,0
	pushn	%r2
	sub	%sp,0xc		; 	xsub	%sp,%sp,48
	ld.w	%r2,%r12
	ld.w	%r0,%r13
	ld.w	%r12,%r0
	ext	sinf@rm		; 	xcall	sinf
	call	sinf@rl
	ld.w	%r1,%r10
	ld.w	%r12,%r0
	ext	cosf@rm		; 	xcall	cosf
	call	cosf@rl
	ld.w	%r0,%r10
	ext	0x7f0		; 	xld.w	%r10,0x3f800000		; 1.00000000000000000000e0
	ext	0x0
	ld.w	%r10,0x0
	ld.w	[%sp+0x0],%r10	; 	xld.w	[%sp],%r10
	ld.w	%r11,0x0	; 	xld.w	%r11,0x00000000		; 0.00000000000000000000e0
	ld.w	[%sp+0x1],%r11	; 	xld.w	[%sp+4],%r11
	ld.w	[%sp+0x2],%r11	; 	xld.w	[%sp+8],%r11
	ld.w	[%sp+0x3],%r11	; 	xld.w	[%sp+12],%r11
	ld.w	[%sp+0x4],%r11	; 	xld.w	[%sp+16],%r11
	ld.w	[%sp+0x5],%r0	; 	xld.w	[%sp+20],%r0
	ld.w	%r12,%r1
	ext	__negsf2@rm	; 	xcall	__negsf2
	call	__negsf2@rl
	ld.w	[%sp+0x6],%r10	; 	xld.w	[%sp+24],%r10
	ld.w	%r11,0x0	; 	xld.w	%r11,0x00000000		; 0.00000000000000000000e0
	ld.w	[%sp+0x7],%r11	; 	xld.w	[%sp+28],%r11
	ld.w	[%sp+0x8],%r11	; 	xld.w	[%sp+32],%r11
	ld.w	[%sp+0x9],%r1	; 	xld.w	[%sp+36],%r1
	ld.w	[%sp+0xa],%r0	; 	xld.w	[%sp+40],%r0
	ld.w	[%sp+0xb],%r11	; 	xld.w	[%sp+44],%r11
	ld.w	%r12,%r2
	ld.w	%r13,%sp
	ext	matf_xform@rm	; 	xcall	matf_xform
	call	matf_xform@rl
	add	%sp,0xc		; 	xadd	%sp,%sp,48
	popn	%r2
	ret
	.align	1
	.global	matf_roty
matf_roty:
;	.frame	%sp,64,$31		# vars= 48, regs= 4/0, args= 0, extra= 0
;	.mask	0x80070000,-4
;	.fmask	0x00000000,0
	pushn	%r2
	sub	%sp,0xc		; 	xsub	%sp,%sp,48
	ld.w	%r2,%r12
	ld.w	%r0,%r13
	ld.w	%r12,%r0
	ext	sinf@rm		; 	xcall	sinf
	call	sinf@rl
	ld.w	%r1,%r10
	ld.w	%r12,%r0
	ext	cosf@rm		; 	xcall	cosf
	call	cosf@rl
	ld.w	%r0,%r10
	ld.w	[%sp+0x0],%r0	; 	xld.w	[%sp],%r0
	ld.w	%r11,0x0	; 	xld.w	%r11,0x00000000		; 0.00000000000000000000e0
	ld.w	[%sp+0x1],%r11	; 	xld.w	[%sp+4],%r11
	ld.w	[%sp+0x2],%r1	; 	xld.w	[%sp+8],%r1
	ld.w	[%sp+0x3],%r11	; 	xld.w	[%sp+12],%r11
	ld.w	[%sp+0x4],%r11	; 	xld.w	[%sp+16],%r11
	ext	0x7f0		; 	xld.w	%r10,0x3f800000		; 1.00000000000000000000e0
	ext	0x0
	ld.w	%r10,0x0
	ld.w	[%sp+0x5],%r10	; 	xld.w	[%sp+20],%r10
	ld.w	[%sp+0x6],%r11	; 	xld.w	[%sp+24],%r11
	ld.w	[%sp+0x7],%r11	; 	xld.w	[%sp+28],%r11
	ld.w	%r12,%r1
	ext	__negsf2@rm	; 	xcall	__negsf2
	call	__negsf2@rl
	ld.w	[%sp+0x8],%r10	; 	xld.w	[%sp+32],%r10
	ld.w	%r11,0x0	; 	xld.w	%r11,0x00000000		; 0.00000000000000000000e0
	ld.w	[%sp+0x9],%r11	; 	xld.w	[%sp+36],%r11
	ld.w	[%sp+0xa],%r0	; 	xld.w	[%sp+40],%r0
	ld.w	[%sp+0xb],%r11	; 	xld.w	[%sp+44],%r11
	ld.w	%r12,%r2
	ld.w	%r13,%sp
	ext	matf_xform@rm	; 	xcall	matf_xform
	call	matf_xform@rl
	add	%sp,0xc		; 	xadd	%sp,%sp,48
	popn	%r2
	ret
	.align	1
	.global	matf_rotz
matf_rotz:
;	.frame	%sp,64,$31		# vars= 48, regs= 4/0, args= 0, extra= 0
;	.mask	0x80070000,-4
;	.fmask	0x00000000,0
	pushn	%r2
	sub	%sp,0xc		; 	xsub	%sp,%sp,48
	ld.w	%r2,%r12
	ld.w	%r0,%r13
	ld.w	%r12,%r0
	ext	sinf@rm		; 	xcall	sinf
	call	sinf@rl
	ld.w	%r1,%r10
	ld.w	%r12,%r0
	ext	cosf@rm		; 	xcall	cosf
	call	cosf@rl
	ld.w	%r0,%r10
	ld.w	[%sp+0x0],%r0	; 	xld.w	[%sp],%r0
	ld.w	%r12,%r1
	ext	__negsf2@rm	; 	xcall	__negsf2
	call	__negsf2@rl
	ld.w	[%sp+0x1],%r10	; 	xld.w	[%sp+4],%r10
	ld.w	%r11,0x0	; 	xld.w	%r11,0x00000000		; 0.00000000000000000000e0
	ld.w	[%sp+0x2],%r11	; 	xld.w	[%sp+8],%r11
	ld.w	[%sp+0x3],%r11	; 	xld.w	[%sp+12],%r11
	ld.w	[%sp+0x4],%r1	; 	xld.w	[%sp+16],%r1
	ld.w	[%sp+0x5],%r0	; 	xld.w	[%sp+20],%r0
	ld.w	[%sp+0x6],%r11	; 	xld.w	[%sp+24],%r11
	ld.w	[%sp+0x7],%r11	; 	xld.w	[%sp+28],%r11
	ld.w	[%sp+0x8],%r11	; 	xld.w	[%sp+32],%r11
	ld.w	[%sp+0x9],%r11	; 	xld.w	[%sp+36],%r11
	ext	0x7f0		; 	xld.w	%r10,0x3f800000		; 1.00000000000000000000e0
	ext	0x0
	ld.w	%r10,0x0
	ld.w	[%sp+0xa],%r10	; 	xld.w	[%sp+40],%r10
	ld.w	[%sp+0xb],%r11	; 	xld.w	[%sp+44],%r11
	ld.w	%r12,%r2
	ld.w	%r13,%sp
	ext	matf_xform@rm	; 	xcall	matf_xform
	call	matf_xform@rl
	add	%sp,0xc		; 	xadd	%sp,%sp,48
	popn	%r2
	ret
	.align	1
	.global	matf_invno
matf_invno:
;	.frame	%sp,108,$31		# vars= 96, regs= 3/0, args= 0, extra= 0
;	.mask	0x80030000,-4
;	.fmask	0x00000000,0
	pushn	%r1
	sub	%sp,0x18	; 	xsub	%sp,%sp,96
	ld.w	%r1,%r12
	ld.w	%r10,[%r1]	; 	xld.w	%r10,[%r1]
	ld.w	[%sp+0xc],%r10	; 	xld.w	[%sp+48],%r10
	ext	0x10		; 	xld.w	%r10,[%r1+16]
	ld.w	%r10,[%r1]
	ld.w	[%sp+0xd],%r10	; 	xld.w	[%sp+52],%r10
	ext	0x20		; 	xld.w	%r10,[%r1+32]
	ld.w	%r10,[%r1]
	ld.w	[%sp+0xe],%r10	; 	xld.w	[%sp+56],%r10
	ld.w	%r12,[%r1]	; 	xld.w	%r12,[%r1]
	ext	0xc		; 	xld.w	%r13,[%r1+12]
	ld.w	%r13,[%r1]
	ext	__mulsf3@rm	; 	xcall	__mulsf3
	call	__mulsf3@rl
	ld.w	%r0,%r10
	ext	0x10		; 	xld.w	%r12,[%r1+16]
	ld.w	%r12,[%r1]
	ext	0x1c		; 	xld.w	%r13,[%r1+28]
	ld.w	%r13,[%r1]
	ext	__mulsf3@rm	; 	xcall	__mulsf3
	call	__mulsf3@rl
	ld.w	%r12,%r0
	ld.w	%r13,%r10
	ext	__addsf3@rm	; 	xcall	__addsf3
	call	__addsf3@rl
	ld.w	%r0,%r10
	ext	0x20		; 	xld.w	%r12,[%r1+32]
	ld.w	%r12,[%r1]
	ext	0x2c		; 	xld.w	%r13,[%r1+44]
	ld.w	%r13,[%r1]
	ext	__mulsf3@rm	; 	xcall	__mulsf3
	call	__mulsf3@rl
	ld.w	%r12,%r0
	ld.w	%r13,%r10
	ext	__addsf3@rm	; 	xcall	__addsf3
	call	__addsf3@rl
	ld.w	%r12,%r10
	ext	__negsf2@rm	; 	xcall	__negsf2
	call	__negsf2@rl
	ld.w	[%sp+0xf],%r10	; 	xld.w	[%sp+60],%r10
	ext	0x4		; 	xld.w	%r10,[%r1+4]
	ld.w	%r10,[%r1]
	ld.w	[%sp+0x10],%r10	; 	xld.w	[%sp+64],%r10
	ext	0x14		; 	xld.w	%r10,[%r1+20]
	ld.w	%r10,[%r1]
	ld.w	[%sp+0x11],%r10	; 	xld.w	[%sp+68],%r10
	ext	0x24		; 	xld.w	%r10,[%r1+36]
	ld.w	%r10,[%r1]
	ld.w	[%sp+0x12],%r10	; 	xld.w	[%sp+72],%r10
	ext	0x4		; 	xld.w	%r12,[%r1+4]
	ld.w	%r12,[%r1]
	ext	0xc		; 	xld.w	%r13,[%r1+12]
	ld.w	%r13,[%r1]
	ext	__mulsf3@rm	; 	xcall	__mulsf3
	call	__mulsf3@rl
	ld.w	%r0,%r10
	ext	0x14		; 	xld.w	%r12,[%r1+20]
	ld.w	%r12,[%r1]
	ext	0x1c		; 	xld.w	%r13,[%r1+28]
	ld.w	%r13,[%r1]
	ext	__mulsf3@rm	; 	xcall	__mulsf3
	call	__mulsf3@rl
	ld.w	%r12,%r0
	ld.w	%r13,%r10
	ext	__addsf3@rm	; 	xcall	__addsf3
	call	__addsf3@rl
	ld.w	%r0,%r10
	ext	0x24		; 	xld.w	%r12,[%r1+36]
	ld.w	%r12,[%r1]
	ext	0x2c		; 	xld.w	%r13,[%r1+44]
	ld.w	%r13,[%r1]
	ext	__mulsf3@rm	; 	xcall	__mulsf3
	call	__mulsf3@rl
	ld.w	%r12,%r0
	ld.w	%r13,%r10
	ext	__addsf3@rm	; 	xcall	__addsf3
	call	__addsf3@rl
	ld.w	%r12,%r10
	ext	__negsf2@rm	; 	xcall	__negsf2
	call	__negsf2@rl
	ld.w	[%sp+0x13],%r10	; 	xld.w	[%sp+76],%r10
	ext	0x8		; 	xld.w	%r10,[%r1+8]
	ld.w	%r10,[%r1]
	ld.w	[%sp+0x14],%r10	; 	xld.w	[%sp+80],%r10
	ext	0x18		; 	xld.w	%r10,[%r1+24]
	ld.w	%r10,[%r1]
	ld.w	[%sp+0x15],%r10	; 	xld.w	[%sp+84],%r10
	ext	0x28		; 	xld.w	%r10,[%r1+40]
	ld.w	%r10,[%r1]
	ld.w	[%sp+0x16],%r10	; 	xld.w	[%sp+88],%r10
	ext	0x8		; 	xld.w	%r12,[%r1+8]
	ld.w	%r12,[%r1]
	ext	0xc		; 	xld.w	%r13,[%r1+12]
	ld.w	%r13,[%r1]
	ext	__mulsf3@rm	; 	xcall	__mulsf3
	call	__mulsf3@rl
	ld.w	%r0,%r10
	ext	0x18		; 	xld.w	%r12,[%r1+24]
	ld.w	%r12,[%r1]
	ext	0x1c		; 	xld.w	%r13,[%r1+28]
	ld.w	%r13,[%r1]
	ext	__mulsf3@rm	; 	xcall	__mulsf3
	call	__mulsf3@rl
	ld.w	%r12,%r0
	ld.w	%r13,%r10
	ext	__addsf3@rm	; 	xcall	__addsf3
	call	__addsf3@rl
	ld.w	%r0,%r10
	ext	0x28		; 	xld.w	%r12,[%r1+40]
	ld.w	%r12,[%r1]
	ext	0x2c		; 	xld.w	%r13,[%r1+44]
	ld.w	%r13,[%r1]
	ext	__mulsf3@rm	; 	xcall	__mulsf3
	call	__mulsf3@rl
	ld.w	%r12,%r0
	ld.w	%r13,%r10
	ext	__addsf3@rm	; 	xcall	__addsf3
	call	__addsf3@rl
	ld.w	%r12,%r10
	ext	__negsf2@rm	; 	xcall	__negsf2
	call	__negsf2@rl
	ld.w	[%sp+0x17],%r10	; 	xld.w	[%sp+92],%r10
	ext	0x0		; 	xld.w	%r0,0x00000030		; 48
	ld.w	%r0,0x30
	ld.w	%r12,%sp
	ld.w	%r13,%sp
	add	%r13,%r0
	ld.w	%r14,%r0
	ext	memcpy@rm	; 	xcall	memcpy
	call	memcpy@rl
	ld.w	%r12,%r1
	ld.w	%r13,%sp
	ld.w	%r14,%r0
	ext	memcpy@rm	; 	xcall	memcpy
	call	memcpy@rl
	add	%sp,0x18	; 	xadd	%sp,%sp,96
	popn	%r1
	ret
	.align	1
	.global	matf_orient
matf_orient:
;	.frame	%sp,148,$31		# vars= 132, regs= 4/0, args= 0, extra= 0
;	.mask	0x80070000,-4
;	.fmask	0x00000000,0
	pushn	%r2
	sub	%sp,0x21	; 	xsub	%sp,%sp,132
	ld.w	%r2,%r12
	ld.w	%r1,%r14
	ld.w	%r12,%sp
	ld.w	%r14,0xc	; 	xld.w	%r14,0x0000000c		; 12
	ext	memcpy@rm	; 	xcall	memcpy
	call	memcpy@rl
	ld.w	%r12,%sp
	ext	vecf_normal@rm	; 	xcall	vecf_normal
	call	vecf_normal@rl
	ld.w	%r0,%sp		; 	xadd	%r0,%sp,12
	add	%r0,0xc
	ld.w	%r12,%r0
	ld.w	%r13,%r1
	ld.w	%r14,%sp
	ext	vecf_cross@rm	; 	xcall	vecf_cross
	call	vecf_cross@rl
	ld.w	%r12,%r0
	ext	vecf_normal@rm	; 	xcall	vecf_normal
	call	vecf_normal@rl
	ld.w	%r12,%sp	; 	xadd	%r12,%sp,24
	add	%r12,0x18
	ld.w	%r13,%sp
	ld.w	%r14,%r0
	ext	vecf_cross@rm	; 	xcall	vecf_cross
	call	vecf_cross@rl
	ld.w	%r10,[%sp+0x3]	; 	xld.w	%r10,[%sp+12]
	ld.w	[%sp+0x15],%r10	; 	xld.w	[%sp+84],%r10
	ld.w	%r10,[%sp+0x6]	; 	xld.w	%r10,[%sp+24]
	ld.w	[%sp+0x16],%r10	; 	xld.w	[%sp+88],%r10
	ld.w	%r10,[%sp+0x0]	; 	xld.w	%r10,[%sp]
	ld.w	[%sp+0x17],%r10	; 	xld.w	[%sp+92],%r10
	ld.w	%r11,0x0	; 	xld.w	%r11,0x00000000		; 0.00000000000000000000e0
	ld.w	[%sp+0x18],%r11	; 	xld.w	[%sp+96],%r11
	ld.w	%r10,[%sp+0x4]	; 	xld.w	%r10,[%sp+16]
	ld.w	[%sp+0x19],%r10	; 	xld.w	[%sp+100],%r10
	ld.w	%r10,[%sp+0x7]	; 	xld.w	%r10,[%sp+28]
	ld.w	[%sp+0x1a],%r10	; 	xld.w	[%sp+104],%r10
	ld.w	%r10,[%sp+0x1]	; 	xld.w	%r10,[%sp+4]
	ld.w	[%sp+0x1b],%r10	; 	xld.w	[%sp+108],%r10
	ld.w	[%sp+0x1c],%r11	; 	xld.w	[%sp+112],%r11
	ld.w	%r10,[%sp+0x5]	; 	xld.w	%r10,[%sp+20]
	ld.w	[%sp+0x1d],%r10	; 	xld.w	[%sp+116],%r10
	ld.w	%r10,[%sp+0x8]	; 	xld.w	%r10,[%sp+32]
	ld.w	[%sp+0x1e],%r10	; 	xld.w	[%sp+120],%r10
	ld.w	%r10,[%sp+0x2]	; 	xld.w	%r10,[%sp+8]
	ld.w	[%sp+0x1f],%r10	; 	xld.w	[%sp+124],%r10
	ld.w	[%sp+0x20],%r11	; 	xld.w	[%sp+128],%r11
	ld.w	%r0,%sp		; 	xadd	%r0,%sp,36
	add	%r0,0x24
	ld.w	%r12,%r0
	ld.w	%r13,%sp	; 	xadd	%r13,%sp,84
	ext	0x1
	add	%r13,0x14
	ext	0x0		; 	xld.w	%r14,0x00000030		; 48
	ld.w	%r14,0x30
	ext	memcpy@rm	; 	xcall	memcpy
	call	memcpy@rl
	ld.w	%r12,%r2
	ld.w	%r13,%r0
	ext	matf_xform@rm	; 	xcall	matf_xform
	call	matf_xform@rl
	add	%sp,0x21	; 	xadd	%sp,%sp,132
	popn	%r2
	ret
	.align	1
	.global	matf_lookat
matf_lookat:
;	.frame	%sp,84,$31		# vars= 64, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	sub	%sp,0x10	; 	xsub	%sp,%sp,64
	ld.w	[%sp+0xf],%r12	; 	xld.w	[%sp+60],%r12
	ld.w	%r0,%r13
	ld.w	%r2,%r14
	ld.w	%r3,%r15
	ld.w	%r1,%sp		; 	xadd	%r1,%sp,12
	add	%r1,0xc
	ld.w	%r12,%r1
	ext	matf_1+0x0@h	; 	xld.w	%r13,matf_1
	ext	matf_1+0x0@m
	ld.w	%r13,matf_1+0x0@l
	ext	0x0		; 	xld.w	%r14,0x00000030		; 48
	ld.w	%r14,0x30
	ext	memcpy@rm	; 	xcall	memcpy
	call	memcpy@rl
	ld.w	%r12,%r1
	ld.w	%r13,[%r0]	; 	xld.w	%r13,[%r0]
	ext	0x4		; 	xld.w	%r14,[%r0+4]
	ld.w	%r14,[%r0]
	ext	0x8		; 	xld.w	%r15,[%r0+8]
	ld.w	%r15,[%r0]
	ext	matf_xlate@rm	; 	xcall	matf_xlate
	call	matf_xlate@rl
	ld.w	%r12,%sp
	ld.w	%r13,%r2
	ld.w	%r14,0xc	; 	xld.w	%r14,0x0000000c		; 12
	ext	memcpy@rm	; 	xcall	memcpy
	call	memcpy@rl
	ld.w	%r12,%sp
	ld.w	%r13,%r0
	ext	vecf_sub@rm	; 	xcall	vecf_sub
	call	vecf_sub@rl
	ld.w	%r12,%r1
	ld.w	%r13,%sp
	ext	vecf_y+0x0@h	; 	xld.w	%r14,vecf_y
	ext	vecf_y+0x0@m
	ld.w	%r14,vecf_y+0x0@l
	call	matf_orient	; 	xcall	matf_orient
	ld.w	%r12,%r1
	ld.w	%r13,%r3
	ext	matf_rotz@rm	; 	xcall	matf_rotz
	call	matf_rotz@rl
	ld.w	%r12,%r1
	ext	matf_invno@rm	; 	xcall	matf_invno
	call	matf_invno@rl
	ld.w	%r12,[%sp+0xf]	; 	xld.w	%r12,[%sp+60]
	ld.w	%r13,%r1
	ext	matf_xform@rm	; 	xcall	matf_xform
	call	matf_xform@rl
	add	%sp,0x10	; 	xadd	%sp,%sp,64
	popn	%r3
	ret
	.align	1
	.global	matf_frustum
matf_frustum:
;	.frame	%sp,116,$31		# vars= 96, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	sub	%sp,0x18	; 	xsub	%sp,%sp,96
	ld.w	%r3,%r12
	ld.w	%r1,%r13
	ld.w	%r2,%r14
	ld.w	%r12,%r15
	ld.w	%r13,%r12
	ext	__addsf3@rm	; 	xcall	__addsf3
	call	__addsf3@rl
	ld.w	%r0,%r10
	ld.w	%r12,%r0
	ld.w	%r13,%r1
	ext	__divsf3@rm	; 	xcall	__divsf3
	call	__divsf3@rl
	ld.w	[%sp+0xc],%r10	; 	xld.w	[%sp+48],%r10
	ld.w	%r11,0x0	; 	xld.w	%r11,0x00000000		; 0.00000000000000000000e0
	ld.w	[%sp+0xd],%r11	; 	xld.w	[%sp+52],%r11
	ld.w	[%sp+0xe],%r11	; 	xld.w	[%sp+56],%r11
	ld.w	[%sp+0xf],%r11	; 	xld.w	[%sp+60],%r11
	ld.w	[%sp+0x10],%r11	; 	xld.w	[%sp+64],%r11
	ld.w	%r12,%r0
	ld.w	%r13,%r2
	ext	__divsf3@rm	; 	xcall	__divsf3
	call	__divsf3@rl
	ld.w	[%sp+0x11],%r10	; 	xld.w	[%sp+68],%r10
	ld.w	%r11,0x0	; 	xld.w	%r11,0x00000000		; 0.00000000000000000000e0
	ld.w	[%sp+0x12],%r11	; 	xld.w	[%sp+72],%r11
	ld.w	[%sp+0x13],%r11	; 	xld.w	[%sp+76],%r11
	ld.w	[%sp+0x14],%r11	; 	xld.w	[%sp+80],%r11
	ld.w	[%sp+0x15],%r11	; 	xld.w	[%sp+84],%r11
	ext	0x7f0		; 	xld.w	%r10,0x3f800000		; 1.00000000000000000000e0
	ext	0x0
	ld.w	%r10,0x0
	ld.w	[%sp+0x16],%r10	; 	xld.w	[%sp+88],%r10
	ld.w	[%sp+0x17],%r11	; 	xld.w	[%sp+92],%r11
	ext	0x0		; 	xld.w	%r14,0x00000030		; 48
	ld.w	%r14,0x30
	ld.w	%r12,%sp
	ld.w	%r13,%sp
	add	%r13,%r14
	ext	memcpy@rm	; 	xcall	memcpy
	call	memcpy@rl
	ld.w	%r12,%r3
	ld.w	%r13,%sp
	ext	matf_xform@rm	; 	xcall	matf_xform
	call	matf_xform@rl
	add	%sp,0x18	; 	xadd	%sp,%sp,96
	popn	%r3
	ret
	.align	1
	.global	matf_perspect
matf_perspect:
;	.frame	%sp,20,$31		# vars= 0, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	ld.w	%r3,%r12
	ld.w	%r12,%r13
	ld.w	%r2,%r14
	ld.w	%r1,%r15
	ext	0x800		; 	xld.w	%r13,0x40000000		; 2.00000000000000000000e0
	ext	0x0
	ld.w	%r13,0x0
	ext	__divsf3@rm	; 	xcall	__divsf3
	call	__divsf3@rl
	ld.w	%r12,%r10
	ext	tanf@rm		; 	xcall	tanf
	call	tanf@rl
	ld.w	%r12,%r1
	ld.w	%r13,%r10
	ext	__mulsf3@rm	; 	xcall	__mulsf3
	call	__mulsf3@rl
	ld.w	%r12,%r10
	ld.w	%r13,%r12
	ext	__addsf3@rm	; 	xcall	__addsf3
	call	__addsf3@rl
	ld.w	%r0,%r10
	ld.w	%r12,%r0
	ld.w	%r13,%r2
	ext	__mulsf3@rm	; 	xcall	__mulsf3
	call	__mulsf3@rl
	ld.w	%r12,%r3
	ld.w	%r13,%r10
	ld.w	%r14,%r0
	ld.w	%r15,%r1
	call	matf_frustum	; 	xcall	matf_frustum
	popn	%r3
	ret
	.align	1
	.global	matf_viewportz
matf_viewportz:
;	.frame	%sp,72,$31		# vars= 52, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	sub	%sp,0xd		; 	xsub	%sp,%sp,52
	ld.w	[%sp+0xc],%r12	; 	xld.w	[%sp+48],%r12
	ld.w	%r2,%r13
	ld.w	%r3,%r14
	ld.w	%r12,%r15
	ext	__floatsisf@rm	; 	xcall	__floatsisf
	call	__floatsisf@rl
	ext	0x800		; 	xld.w	%r1,0x40000000		; 2.00000000000000000000e0
	ext	0x0
	ld.w	%r1,0x0
	ld.w	%r12,%r10
	ld.w	%r13,%r1
	ext	__divsf3@rm	; 	xcall	__divsf3
	call	__divsf3@rl
	ld.w	%r0,%r10
	ld.w	[%sp+0x0],%r0	; 	xld.w	[%sp],%r0
	ld.w	%r11,0x0	; 	xld.w	%r11,0x00000000		; 0.00000000000000000000e0
	ld.w	[%sp+0x1],%r11	; 	xld.w	[%sp+4],%r11
	ld.w	%r12,%r2
	ext	__floatsisf@rm	; 	xcall	__floatsisf
	call	__floatsisf@rl
	ld.w	%r12,%r10
	ld.w	%r13,%r0
	ext	__addsf3@rm	; 	xcall	__addsf3
	call	__addsf3@rl
	ld.w	[%sp+0x2],%r10	; 	xld.w	[%sp+8],%r10
	ld.w	%r11,0x0	; 	xld.w	%r11,0x00000000		; 0.00000000000000000000e0
	ld.w	[%sp+0x3],%r11	; 	xld.w	[%sp+12],%r11
	ld.w	[%sp+0x4],%r11	; 	xld.w	[%sp+16],%r11
	ld.w	%r11,[%sp+0x12]	; 	xld.w	%r11,[%sp+72]
	not	%r12,%r11
	add	%r12,1
	ext	__floatsisf@rm	; 	xcall	__floatsisf
	call	__floatsisf@rl
	ld.w	%r12,%r10
	ld.w	%r13,%r1
	ext	__divsf3@rm	; 	xcall	__divsf3
	call	__divsf3@rl
	ld.w	[%sp+0x5],%r10	; 	xld.w	[%sp+20],%r10
	ld.w	%r12,%r3
	ext	__floatsisf@rm	; 	xcall	__floatsisf
	call	__floatsisf@rl
	ld.w	%r0,%r10
	ld.w	%r12,[%sp+0x12]	; 	xld.w	%r12,[%sp+72]
	ext	__floatsisf@rm	; 	xcall	__floatsisf
	call	__floatsisf@rl
	ld.w	%r12,%r10
	ld.w	%r13,%r1
	ext	__divsf3@rm	; 	xcall	__divsf3
	call	__divsf3@rl
	ld.w	%r12,%r0
	ld.w	%r13,%r10
	ext	__addsf3@rm	; 	xcall	__addsf3
	call	__addsf3@rl
	ld.w	[%sp+0x6],%r10	; 	xld.w	[%sp+24],%r10
	ld.w	%r11,0x0	; 	xld.w	%r11,0x00000000		; 0.00000000000000000000e0
	ld.w	[%sp+0x7],%r11	; 	xld.w	[%sp+28],%r11
	ld.w	[%sp+0x8],%r11	; 	xld.w	[%sp+32],%r11
	ld.w	[%sp+0x9],%r11	; 	xld.w	[%sp+36],%r11
	ext	0x7f0		; 	xld.w	%r10,0x3f800000		; 1.00000000000000000000e0
	ext	0x0
	ld.w	%r10,0x0
	ld.w	[%sp+0xa],%r10	; 	xld.w	[%sp+40],%r10
	ld.w	[%sp+0xb],%r11	; 	xld.w	[%sp+44],%r11
	ld.w	%r12,[%sp+0xc]	; 	xld.w	%r12,[%sp+48]
	ld.w	%r13,%sp
	ext	matf_xform@rm	; 	xcall	matf_xform
	call	matf_xform@rl
	add	%sp,0xd		; 	xadd	%sp,%sp,52
	popn	%r3
	ret
